---

- name: "Create JumpHost's user"
  user:
    name: "{{ jumphost_user }}"
    comment: "JumpHost User"

- name: Create special authorized_keys directory
  file:
    path: "{{ authkeys_dir }}"
    state: directory
    owner: root
    group: root
    mode: "0755"

- name: Install JumpHost user's SSH Authorizations
  template:
    src: "{{ data_dir }}/authorized_keys"
    dest: "{{ authkeys_dir }}/{{ jumphost_user }}"
    owner: root
    group: "{{ jumphost_user }}"
    mode: "0640"

- name: "SSH JumpHost Configuration"
  blockinfile:
    path: /etc/ssh/sshd_config
    owner: root
    group: root
    # using AuthenticationMethods because ChallengeResponseAuthentication cannot be set in a Match block (and PasswordAuthentication is not sufficient)
    # using AuthorizedKeysFile so user can't modify its own list of authorized keys
    block: |
      Match User {{ jumphost_user }}
        AuthorizedKeysFile {{ authkeys_dir }}/%u
        AuthenticationMethods publickey
        PermitTTY no
        X11Forwarding no
        AllowStreamLocalForwarding no
        AllowAgentForwarding no
        ForceCommand echo 'This account can only be used for ProxyJump (ssh -J)'
        {% if jumphost_acls is defined and jumphost_acls %}PermitOpen {{ jumphost_acls | join(' ') }}{% endif %}
    marker: "# {mark} ANSIBLE MANAGED BLOCK JumpHost for user '{{ jumphost_user }}'"
  notify: Restart SSH Service

